'''complextools.sage - Created by Noud Aldenhoven (2015)'''

q, z, x = var('q z x')

def replace_z_x(polynomial):
    '''replace_z_x(polynomial): substitute (z + z^(-1))/2 |-> x in polynomial.'''

    ret_poly = 0

    while polynomial.full_simplify() != 0:
        coef = polynomial.coefficients(z)
        coef = [ c for c in coef if c[0] != 0 ]

        constant = True
        for c, dg in coef:
            if dg != 0 and c != 0:
                constant = False        

        if constant:
            return ret_poly + polynomial.full_simplify()

        first, last = coef[0], coef[-1]

        if not (first[0] == last[0] and first[1] == -last[1]):
            return None
        
        ret_poly += first[0]*(2*x)**(last[1])
        polynomial -= first[0]*(z + z**(-1))**(last[1])

    return ret_poly


def replace_x_z(polynomial):
    '''replace_x_z(polynomial): substitute x |-> (z + z^(-1))/2 in polynomial.'''

    return polynomial.substitute({x : (z + z**(-1))/2})
